Index: uspace/lib/c/include/vfs/vfs.h
===================================================================
--- uspace/lib/c/include/vfs/vfs.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/include/vfs/vfs.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -42,6 +42,6 @@
 #include <stdio.h>
 #include <async.h>
-#include "vfs_mtab.h"
 
+#define MAX_OPEN_FILES	128
 
 enum vfs_change_state_type {
@@ -49,18 +49,66 @@
 };
 
+typedef enum {
+	KIND_FILE,
+	KIND_DIRECTORY,
+} vfs_file_kind_t;
 
-extern char *vfs_absolutize(const char *, size_t *);
 
-extern int vfs_mount(const char *, const char *, const char *, const char *,
-    unsigned int, unsigned int);
-extern int vfs_unmount(const char *);
+struct stat {
+	fs_handle_t fs_handle;
+	service_id_t service_id;
+	fs_index_t index;
+	unsigned int lnkcnt;
+	bool is_file;
+	bool is_directory;
+	aoff64_t size;
+	service_id_t service;
+};
+
+struct statfs { 
+	char fs_name[FS_NAME_MAXLEN + 1];
+	uint32_t f_bsize;    /* fundamental file system block size */
+	uint64_t f_blocks;   /* total data blocks in file system */
+	uint64_t f_bfree;    /* free blocks in fs */
+};
 
 extern int vfs_fhandle(FILE *, int *);
 
-extern int vfs_fd_wait(void);
-extern int vfs_get_mtab_list(list_t *mtab_list);
-
+extern char *vfs_absolutize(const char *, size_t *);
+extern int vfs_clone(int, int, bool);
+extern int vfs_cwd_get(char *path, size_t);
+extern int vfs_cwd_set(const char *path);
 extern async_exch_t *vfs_exchange_begin(void);
 extern void vfs_exchange_end(async_exch_t *);
+extern int vfs_link(int, const char *, vfs_file_kind_t, int *);
+extern int vfs_link_path(const char *, vfs_file_kind_t, int *);
+extern int vfs_lookup(const char *, int);
+extern int vfs_lookup_open(const char *, int, int);
+extern int vfs_mount_path(const char *, const char *, const char *,
+    const char *, unsigned int, unsigned int);
+extern int vfs_mount(int, const char *, service_id_t, const char *, unsigned,
+    unsigned, int *);
+extern int vfs_open(int, int);
+extern int vfs_pass_handle(async_exch_t *, int, async_exch_t *);
+extern int vfs_put(int);
+extern ssize_t vfs_read(int, aoff64_t *, void *, size_t);
+extern int vfs_read_short(int, aoff64_t, void *, size_t, ssize_t *);
+extern int vfs_receive_handle(bool);
+extern int vfs_rename_path(const char *, const char *);
+extern int vfs_resize(int, aoff64_t);
+extern int vfs_root(void);
+extern void vfs_root_set(int);
+extern int vfs_stat(int, struct stat *);
+extern int vfs_stat_path(const char *, struct stat *);
+extern int vfs_statfs(int, struct statfs *);
+extern int vfs_statfs_path(const char *, struct statfs *);
+extern int vfs_sync(int);
+extern int vfs_unlink(int, const char *, int);
+extern int vfs_unlink_path(const char *);
+extern int vfs_unmount(int);
+extern int vfs_unmount_path(const char *);
+extern int vfs_walk(int, const char *, int);
+extern ssize_t vfs_write(int, aoff64_t *, const void *, size_t);
+extern int vfs_write_short(int, aoff64_t, const void *, size_t, ssize_t *);
 
 #endif
Index: uspace/lib/c/include/vfs/vfs_mtab.h
===================================================================
--- uspace/lib/c/include/vfs/vfs_mtab.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/include/vfs/vfs_mtab.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -43,9 +43,9 @@
 	link_t link;
 	char mp[MAX_PATH_LEN];
-	char opts[MAX_MNTOPTS_LEN];
 	char fs_name[FS_NAME_MAXLEN];
-	unsigned int instance;
 	service_id_t service_id;
 } mtab_ent_t;
+
+extern int vfs_get_mtab_list(list_t *);
 
 #endif
Index: uspace/lib/fs/libfs.c
===================================================================
--- uspace/lib/fs/libfs.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/fs/libfs.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -36,5 +36,4 @@
 
 #include "libfs.h"
-#include "../../srv/vfs/vfs.h"
 #include <macros.h>
 #include <errno.h>
@@ -44,7 +43,9 @@
 #include <dirent.h>
 #include <mem.h>
-#include <sys/stat.h>
-#include <sys/statfs.h>
+#include <str.h>
 #include <stdlib.h>
+#include <fibril_synch.h>
+#include <ipc/vfs.h>
+#include <vfs/vfs.h>
 
 #define on_error(rc, action) \
@@ -68,6 +69,8 @@
 static libfs_ops_t *libfs_ops = NULL;
 
-static void libfs_mount(libfs_ops_t *, fs_handle_t, ipc_callid_t, ipc_call_t *);
-static void libfs_unmount(libfs_ops_t *, ipc_callid_t, ipc_call_t *);
+static char fs_name[FS_NAME_MAXLEN + 1];
+
+static void libfs_link(libfs_ops_t *, fs_handle_t, ipc_callid_t,
+    ipc_call_t *);
 static void libfs_lookup(libfs_ops_t *, fs_handle_t, ipc_callid_t,
     ipc_call_t *);
@@ -75,5 +78,6 @@
 static void libfs_open_node(libfs_ops_t *, fs_handle_t, ipc_callid_t,
     ipc_call_t *);
-static void libfs_statfs(libfs_ops_t *, fs_handle_t, ipc_callid_t, ipc_call_t *);
+static void libfs_statfs(libfs_ops_t *, fs_handle_t, ipc_callid_t,
+    ipc_call_t *);
 
 static void vfs_out_mounted(ipc_callid_t rid, ipc_call_t *req)
@@ -104,9 +108,4 @@
 }
 
-static void vfs_out_mount(ipc_callid_t rid, ipc_call_t *req)
-{
-	libfs_mount(libfs_ops, reg.fs_handle, rid, req);
-}
-
 static void vfs_out_unmounted(ipc_callid_t rid, ipc_call_t *req)
 {
@@ -119,8 +118,7 @@
 }
 
-static void vfs_out_unmount(ipc_callid_t rid, ipc_call_t *req)
-{
-		
-	libfs_unmount(libfs_ops, rid, req);
+static void vfs_out_link(ipc_callid_t rid, ipc_call_t *req)
+{
+	libfs_link(libfs_ops, reg.fs_handle, rid, req);
 }
 
@@ -159,7 +157,8 @@
 	rc = vfs_out_ops->write(service_id, index, pos, &wbytes, &nsize);
 
-	if (rc == EOK)
-		async_answer_3(rid, EOK, wbytes, LOWER32(nsize), UPPER32(nsize));
-	else
+	if (rc == EOK) {
+		async_answer_3(rid, EOK, wbytes, LOWER32(nsize),
+		    UPPER32(nsize));
+	} else
 		async_answer_0(rid, rc);
 }
@@ -193,8 +192,14 @@
 	service_id_t service_id = (service_id_t) IPC_GET_ARG1(*req);
 	fs_index_t index = (fs_index_t) IPC_GET_ARG2(*req);
+
 	int rc;
-
-	rc = vfs_out_ops->destroy(service_id, index);
-
+	fs_node_t *node = NULL;
+	rc = libfs_ops->node_get(&node, service_id, index);
+	if (rc == EOK && node != NULL) {
+		bool destroy = (libfs_ops->lnkcnt_get(node) == 0);
+		libfs_ops->node_put(node);
+		if (destroy)
+			rc = vfs_out_ops->destroy(service_id, index);
+	}
 	async_answer_0(rid, rc);
 }
@@ -225,4 +230,27 @@
 	libfs_statfs(libfs_ops, reg.fs_handle, rid, req);
 }
+
+static void vfs_out_is_empty(ipc_callid_t rid, ipc_call_t *req)
+{
+	service_id_t service_id = (service_id_t) IPC_GET_ARG1(*req);
+	fs_index_t index = (fs_index_t) IPC_GET_ARG2(*req);
+	int rc;
+
+	fs_node_t *node = NULL;
+	rc = libfs_ops->node_get(&node, service_id, index);
+	if (rc != EOK)
+		async_answer_0(rid, rc);
+	if (node == NULL)
+		async_answer_0(rid, EINVAL);
+	
+	bool children = false;
+	rc = libfs_ops->has_children(&children, node);
+	libfs_ops->node_put(node);
+	
+	if (rc != EOK)
+		async_answer_0(rid, rc);
+	async_answer_0(rid, children ? ENOTEMPTY : EOK);
+}
+
 static void vfs_connection(ipc_callid_t iid, ipc_call_t *icall, void *arg)
 {
@@ -247,12 +275,9 @@
 			vfs_out_mounted(callid, &call);
 			break;
-		case VFS_OUT_MOUNT:
-			vfs_out_mount(callid, &call);
-			break;
 		case VFS_OUT_UNMOUNTED:
 			vfs_out_unmounted(callid, &call);
 			break;
-		case VFS_OUT_UNMOUNT:
-			vfs_out_unmount(callid, &call);
+		case VFS_OUT_LINK:
+			vfs_out_link(callid, &call);
 			break;
 		case VFS_OUT_LOOKUP:
@@ -285,4 +310,7 @@
 		case VFS_OUT_STATFS:
 			vfs_out_statfs(callid, &call);
+			break;
+		case VFS_OUT_IS_EMPTY:
+			vfs_out_is_empty(callid, &call);
 			break;
 		default:
@@ -338,4 +366,6 @@
 	vfs_out_ops = vops;
 	libfs_ops = lops;
+
+	str_cpy(fs_name, sizeof(fs_name), info->name);
 
 	/*
@@ -383,116 +413,88 @@
 }
 
-void libfs_mount(libfs_ops_t *ops, fs_handle_t fs_handle, ipc_callid_t rid,
+static char plb_get_char(unsigned pos)
+{
+	return reg.plb_ro[pos % PLB_SIZE];
+}
+
+static int plb_get_component(char *dest, unsigned *sz, unsigned *ppos,
+    unsigned last)
+{
+	unsigned pos = *ppos;
+	unsigned size = 0;
+	
+	if (pos == last) {
+		*sz = 0;
+		return ERANGE;
+	}
+
+	char c = plb_get_char(pos); 
+	if (c == '/')
+		pos++;
+	
+	for (int i = 0; i <= NAME_MAX; i++) {
+		c = plb_get_char(pos);
+		if (pos == last || c == '/') {
+			dest[i] = 0;
+			*ppos = pos;
+			*sz = size;
+			return EOK;
+		}
+		dest[i] = c;
+		pos++;
+		size++;
+	}
+	return ENAMETOOLONG;
+}
+
+static int receive_fname(char *buffer)
+{
+	size_t size;
+	ipc_callid_t wcall;
+	
+	if (!async_data_write_receive(&wcall, &size))
+		return ENOENT;
+	if (size > NAME_MAX + 1) {
+		async_answer_0(wcall, ERANGE);
+		return ERANGE;
+	}
+	return async_data_write_finalize(wcall, buffer, size);
+}
+
+/** Link a file at a path.
+ */
+void libfs_link(libfs_ops_t *ops, fs_handle_t fs_handle, ipc_callid_t rid,
     ipc_call_t *req)
 {
-	service_id_t mp_service_id = (service_id_t) IPC_GET_ARG1(*req);
-	fs_index_t mp_fs_index = (fs_index_t) IPC_GET_ARG2(*req);
-	fs_handle_t mr_fs_handle = (fs_handle_t) IPC_GET_ARG3(*req);
-	service_id_t mr_service_id = (service_id_t) IPC_GET_ARG4(*req);
-	
-	async_sess_t *mountee_sess = async_clone_receive(EXCHANGE_PARALLEL);
-	if (mountee_sess == NULL) {
-		async_answer_0(rid, EINVAL);
+	service_id_t parent_sid = IPC_GET_ARG1(*req);
+	fs_index_t parent_index = IPC_GET_ARG2(*req);
+	fs_index_t child_index = IPC_GET_ARG3(*req);
+	
+	char component[NAME_MAX + 1];
+	int rc = receive_fname(component);
+	if (rc != EOK) {
+		async_answer_0(rid, rc);
 		return;
 	}
-	
-	fs_node_t *fn;
-	int res = ops->node_get(&fn, mp_service_id, mp_fs_index);
-	if ((res != EOK) || (!fn)) {
-		async_hangup(mountee_sess);
-		async_data_write_void(combine_rc(res, ENOENT));
-		async_answer_0(rid, combine_rc(res, ENOENT));
+
+	fs_node_t *parent = NULL;
+	rc = ops->node_get(&parent, parent_sid, parent_index);
+	if (parent == NULL) {
+		async_answer_0(rid, rc == EOK ? EBADF : rc);
 		return;
 	}
 	
-	if (fn->mp_data.mp_active) {
-		async_hangup(mountee_sess);
-		(void) ops->node_put(fn);
-		async_data_write_void(EBUSY);
-		async_answer_0(rid, EBUSY);
+	fs_node_t *child = NULL;
+	rc = ops->node_get(&child, parent_sid, child_index);
+	if (child == NULL) {
+		async_answer_0(rid, rc == EOK ? EBADF : rc);
+		ops->node_put(parent);
 		return;
 	}
 	
-	async_exch_t *exch = async_exchange_begin(mountee_sess);
-	async_sess_t *sess = async_clone_establish(EXCHANGE_PARALLEL, exch);
-	
-	if (!sess) {
-		async_exchange_end(exch);
-		async_hangup(mountee_sess);
-		(void) ops->node_put(fn);
-		async_data_write_void(errno);
-		async_answer_0(rid, errno);
-		return;
-	}
-	
-	ipc_call_t answer;
-	int rc = async_data_write_forward_1_1(exch, VFS_OUT_MOUNTED,
-	    mr_service_id, &answer);
-	async_exchange_end(exch);
-	
-	if (rc == EOK) {
-		fn->mp_data.mp_active = true;
-		fn->mp_data.fs_handle = mr_fs_handle;
-		fn->mp_data.service_id = mr_service_id;
-		fn->mp_data.sess = mountee_sess;
-	}
-	
-	/*
-	 * Do not release the FS node so that it stays in memory.
-	 */
-	async_answer_4(rid, rc, IPC_GET_ARG1(answer), IPC_GET_ARG2(answer),
-	    IPC_GET_ARG3(answer), IPC_GET_ARG4(answer));
-}
-
-void libfs_unmount(libfs_ops_t *ops, ipc_callid_t rid, ipc_call_t *req)
-{
-	service_id_t mp_service_id = (service_id_t) IPC_GET_ARG1(*req);
-	fs_index_t mp_fs_index = (fs_index_t) IPC_GET_ARG2(*req);
-	fs_node_t *fn;
-	int res;
-
-	res = ops->node_get(&fn, mp_service_id, mp_fs_index);
-	if ((res != EOK) || (!fn)) {
-		async_answer_0(rid, combine_rc(res, ENOENT));
-		return;
-	}
-
-	/*
-	 * We are clearly expecting to find the mount point active.
-	 */
-	if (!fn->mp_data.mp_active) {
-		(void) ops->node_put(fn);
-		async_answer_0(rid, EINVAL);
-		return;
-	}
-
-	/*
-	 * Tell the mounted file system to unmount.
-	 */
-	async_exch_t *exch = async_exchange_begin(fn->mp_data.sess);
-	res = async_req_1_0(exch, VFS_OUT_UNMOUNTED, fn->mp_data.service_id);
-	async_exchange_end(exch);
-
-	/*
-	 * If everything went well, perform the clean-up on our side.
-	 */
-	if (res == EOK) {
-		async_hangup(fn->mp_data.sess);
-		fn->mp_data.mp_active = false;
-		fn->mp_data.fs_handle = 0;
-		fn->mp_data.service_id = 0;
-		fn->mp_data.sess = NULL;
-		
-		/* Drop the reference created in libfs_mount(). */
-		(void) ops->node_put(fn);
-	}
-
-	(void) ops->node_put(fn);
-	async_answer_0(rid, res);
-}
-
-static char plb_get_char(unsigned pos)
-{
-	return reg.plb_ro[pos % PLB_SIZE];
+	rc = ops->link(parent, child, component);
+	ops->node_put(parent);
+	ops->node_put(child);
+	async_answer_0(rid, rc);
 }
 
@@ -513,284 +515,171 @@
     ipc_call_t *req)
 {
-	unsigned int first = IPC_GET_ARG1(*req);
-	unsigned int last = IPC_GET_ARG2(*req);
-	unsigned int next = first;
+	unsigned first = IPC_GET_ARG1(*req);
+	unsigned len = IPC_GET_ARG2(*req);
 	service_id_t service_id = IPC_GET_ARG3(*req);
-	int lflag = IPC_GET_ARG4(*req);
-	fs_index_t index = IPC_GET_ARG5(*req);
+	fs_index_t index = IPC_GET_ARG4(*req);
+	int lflag = IPC_GET_ARG5(*req);
+	
+	// TODO: Validate flags.
+	
+	unsigned next = first;
+	unsigned last = first + len;
+	
 	char component[NAME_MAX + 1];
-	int len;
 	int rc;
-	
-	if (last < next)
-		last += PLB_SIZE;
 	
 	fs_node_t *par = NULL;
 	fs_node_t *cur = NULL;
 	fs_node_t *tmp = NULL;
-	
-	rc = ops->root_get(&cur, service_id);
-	on_error(rc, goto out_with_answer);
-	
-	if (cur->mp_data.mp_active) {
-		async_exch_t *exch = async_exchange_begin(cur->mp_data.sess);
-		async_forward_slow(rid, exch, VFS_OUT_LOOKUP, next, last,
-		    cur->mp_data.service_id, lflag, index,
-		    IPC_FF_ROUTE_FROM_ME);
-		async_exchange_end(exch);
+	unsigned clen = 0;
+	
+	rc = ops->node_get(&cur, service_id, index);
+	if (rc != EOK) {
+		async_answer_0(rid, rc);
+		goto out;
+	}
+	
+	assert(cur != NULL);
+	
+	/* Find the file and its parent. */
+	
+	unsigned last_next = 0;
+	
+	while (next != last) {
+		if (cur == NULL) {
+			assert(par != NULL);
+			goto out1;
+		}
+
+		if (!ops->is_directory(cur)) {
+			async_answer_0(rid, ENOTDIR);
+			goto out;
+		}
 		
-		(void) ops->node_put(cur);
-		return;
-	}
-	
-	/* Eat slash */
-	if (plb_get_char(next) == '/')
-		next++;
-	
-	while (next <= last) {
-		bool has_children;
+		last_next = next;
+		/* Collect the component */
+		rc = plb_get_component(component, &clen, &next, last);
+		assert(rc != ERANGE);
+		if (rc != EOK) {
+			async_answer_0(rid, rc);
+			goto out;
+		}
 		
-		rc = ops->has_children(&has_children, cur);
-		on_error(rc, goto out_with_answer);
-		if (!has_children)
-			break;
+		if (clen == 0) {
+			/* The path is just "/". */
+			break;
+		}
 		
-		/* Collect the component */
-		len = 0;
-		while ((next <= last) && (plb_get_char(next) != '/')) {
-			if (len + 1 == NAME_MAX) {
-				/* Component length overflow */
-				async_answer_0(rid, ENAMETOOLONG);
-				goto out;
-			}
-			component[len++] = plb_get_char(next);
-			/* Process next character */
-			next++;
-		}
-		
-		assert(len);
-		component[len] = '\0';
-		/* Eat slash */
-		next++;
+		assert(component[clen] == 0);
 		
 		/* Match the component */
 		rc = ops->match(&tmp, cur, component);
-		on_error(rc, goto out_with_answer);
+		if (rc != EOK) {
+			async_answer_0(rid, rc);
+			goto out;
+		}
 		
-		/*
-		 * If the matching component is a mount point, there are two
-		 * legitimate semantics of the lookup operation. The first is
-		 * the commonly used one in which the lookup crosses each mount
-		 * point into the mounted file system. The second semantics is
-		 * used mostly during unmount() and differs from the first one
-		 * only in that the last mount point in the looked up path,
-		 * which is also its last component, is not crossed.
-		 */
-
-		if ((tmp) && (tmp->mp_data.mp_active) &&
-		    (!(lflag & L_MP) || (next <= last))) {
-			if (next > last)
-				next = last = first;
-			else
-				next--;
-			
-			async_exch_t *exch = async_exchange_begin(tmp->mp_data.sess);
-			async_forward_slow(rid, exch, VFS_OUT_LOOKUP, next,
-			    last, tmp->mp_data.service_id, lflag, index,
-			    IPC_FF_ROUTE_FROM_ME);
-			async_exchange_end(exch);
-			
-			(void) ops->node_put(cur);
-			(void) ops->node_put(tmp);
-			if (par)
-				(void) ops->node_put(par);
-			return;
+		/* Descend one level */
+		if (par) {
+			rc = ops->node_put(par);
+			if (rc != EOK) {
+				async_answer_0(rid, rc);
+				goto out;
+			}
 		}
 		
-		/* Handle miss: match amongst siblings */
-		if (!tmp) {
-			if (next <= last) {
-				/* There are unprocessed components */
-				async_answer_0(rid, ENOENT);
+		par = cur;
+		cur = tmp;
+		tmp = NULL;
+	}
+	
+	/* At this point, par is either NULL or a directory.
+	 * If cur is NULL, the looked up file does not exist yet.
+	 */
+	 
+	assert(par == NULL || ops->is_directory(par));
+	assert(par != NULL || cur != NULL);
+	
+	/* Check for some error conditions. */
+	
+	if (cur && (lflag & L_FILE) && (ops->is_directory(cur))) {
+		async_answer_0(rid, EISDIR);
+		goto out;
+	}
+	
+	if (cur && (lflag & L_DIRECTORY) && (ops->is_file(cur))) {
+		async_answer_0(rid, ENOTDIR);
+		goto out;
+	}
+	
+	/* Unlink. */
+	
+	if (lflag & L_UNLINK) {
+		if (!cur) {
+			async_answer_0(rid, ENOENT);
+			goto out;
+		}
+		if (!par) {
+			async_answer_0(rid, EINVAL);
+			goto out;
+		}
+		
+		rc = ops->unlink(par, cur, component);
+		if (rc == EOK) {
+			aoff64_t size = ops->size_get(cur);
+			async_answer_5(rid, fs_handle, service_id,
+			    ops->index_get(cur),
+			    (ops->is_directory(cur) << 16) | last,
+			    LOWER32(size), UPPER32(size));
+		} else {
+			async_answer_0(rid, rc);
+		}
+		goto out;
+	}
+	
+	/* Create. */
+	
+	if (lflag & L_CREATE) {
+		if (cur && (lflag & L_EXCLUSIVE)) {
+			async_answer_0(rid, EEXIST);
+			goto out;
+		}
+	
+		if (!cur) {
+			rc = ops->create(&cur, service_id,
+			    lflag & (L_FILE | L_DIRECTORY));
+			if (rc != EOK) {
+				async_answer_0(rid, rc);
+				goto out;
+			}
+			if (!cur) {
+				async_answer_0(rid, ENOSPC);
 				goto out;
 			}
 			
-			/* Miss in the last component */
-			if (lflag & (L_CREATE | L_LINK)) {
-				/* Request to create a new link */
-				if (!ops->is_directory(cur)) {
-					async_answer_0(rid, ENOTDIR);
-					goto out;
-				}
-				
-				fs_node_t *fn;
-				if (lflag & L_CREATE)
-					rc = ops->create(&fn, service_id,
-					    lflag);
-				else
-					rc = ops->node_get(&fn, service_id,
-					    index);
-				on_error(rc, goto out_with_answer);
-				
-				if (fn) {
-					rc = ops->link(cur, fn, component);
-					if (rc != EOK) {
-						if (lflag & L_CREATE)
-							(void) ops->destroy(fn);
-						else
-							(void) ops->node_put(fn);
-						async_answer_0(rid, rc);
-					} else {
-						(void) ops->node_put(cur);
-						cur = fn;
-						goto out_with_answer;
-					}
-				} else
-					async_answer_0(rid, ENOSPC);
-				
+			rc = ops->link(par, cur, component);
+			if (rc != EOK) {
+				(void) ops->destroy(cur);
+				cur = NULL;
+				async_answer_0(rid, rc);
 				goto out;
 			}
-			
-			async_answer_0(rid, ENOENT);
-			goto out;
-		}
-		
-		if (par) {
-			rc = ops->node_put(par);
-			on_error(rc, goto out_with_answer);
-		}
-		
-		/* Descend one level */
-		par = cur;
-		cur = tmp;
-		tmp = NULL;
-	}
-	
-	/* Handle miss: excessive components */
-	if (next <= last) {
-		bool has_children;
-		rc = ops->has_children(&has_children, cur);
-		on_error(rc, goto out_with_answer);
-		
-		if (has_children)
-			goto skip_miss;
-		
-		if (lflag & (L_CREATE | L_LINK)) {
-			if (!ops->is_directory(cur)) {
-				async_answer_0(rid, ENOTDIR);
-				goto out;
-			}
-			
-			/* Collect next component */
-			len = 0;
-			while (next <= last) {
-				if (plb_get_char(next) == '/') {
-					/* More than one component */
-					async_answer_0(rid, ENOENT);
-					goto out;
-				}
-				
-				if (len + 1 == NAME_MAX) {
-					/* Component length overflow */
-					async_answer_0(rid, ENAMETOOLONG);
-					goto out;
-				}
-				
-				component[len++] = plb_get_char(next);
-				/* Process next character */
-				next++;
-			}
-			
-			assert(len);
-			component[len] = '\0';
-			
-			fs_node_t *fn;
-			if (lflag & L_CREATE)
-				rc = ops->create(&fn, service_id, lflag);
-			else
-				rc = ops->node_get(&fn, service_id, index);
-			on_error(rc, goto out_with_answer);
-			
-			if (fn) {
-				rc = ops->link(cur, fn, component);
-				if (rc != EOK) {
-					if (lflag & L_CREATE)
-						(void) ops->destroy(fn);
-					else
-						(void) ops->node_put(fn);
-					async_answer_0(rid, rc);
-				} else {
-					(void) ops->node_put(cur);
-					cur = fn;
-					goto out_with_answer;
-				}
-			} else
-				async_answer_0(rid, ENOSPC);
-			
-			goto out;
-		}
-		
-		async_answer_0(rid, ENOENT);
+		}
+	}
+	
+	/* Return. */
+out1:
+	if (!cur) {
+		async_answer_5(rid, fs_handle, service_id, ops->index_get(par),
+		    last_next, -1, true);
 		goto out;
 	}
 	
-skip_miss:
-	
-	/* Handle hit */
-	if (lflag & L_UNLINK) {
-		unsigned int old_lnkcnt = ops->lnkcnt_get(cur);
-		rc = ops->unlink(par, cur, component);
-		
-		if (rc == EOK) {
-			aoff64_t size = ops->size_get(cur);
-			async_answer_5(rid, fs_handle, service_id,
-			    ops->index_get(cur), LOWER32(size), UPPER32(size),
-			    old_lnkcnt);
-		} else
-			async_answer_0(rid, rc);
-		
-		goto out;
-	}
-	
-	if (((lflag & (L_CREATE | L_EXCLUSIVE)) == (L_CREATE | L_EXCLUSIVE)) ||
-	    (lflag & L_LINK)) {
-		async_answer_0(rid, EEXIST);
-		goto out;
-	}
-	
-	if ((lflag & L_FILE) && (ops->is_directory(cur))) {
-		async_answer_0(rid, EISDIR);
-		goto out;
-	}
-	
-	if ((lflag & L_DIRECTORY) && (ops->is_file(cur))) {
-		async_answer_0(rid, ENOTDIR);
-		goto out;
-	}
-
-	if ((lflag & L_ROOT) && par) {
-		async_answer_0(rid, EINVAL);
-		goto out;
-	}
-	
-out_with_answer:
-	
-	if (rc == EOK) {
-		if (lflag & L_OPEN)
-			rc = ops->node_open(cur);
-		
-		if (rc == EOK) {
-			aoff64_t size = ops->size_get(cur);
-			async_answer_5(rid, fs_handle, service_id,
-			    ops->index_get(cur), LOWER32(size), UPPER32(size),
-			    ops->lnkcnt_get(cur));
-		} else
-			async_answer_0(rid, rc);
-		
-	} else
-		async_answer_0(rid, rc);
+	aoff64_t size = ops->size_get(cur);
+	async_answer_5(rid, fs_handle, service_id, ops->index_get(cur),
+	    (ops->is_directory(cur) << 16) | last, LOWER32(size),
+	    UPPER32(size));
 	
 out:
-	
 	if (par)
 		(void) ops->node_put(par);
@@ -862,4 +751,6 @@
 	memset(&st, 0, sizeof(struct statfs));
 
+	str_cpy(st.fs_name, sizeof(st.fs_name), fs_name);
+
 	if (ops->size_block != NULL) {
 		rc = ops->size_block(service_id, &st.f_bsize);
@@ -919,5 +810,6 @@
 	async_answer_4(rid, rc, LOWER32(size), UPPER32(size),
 	    ops->lnkcnt_get(fn),
-	    (ops->is_file(fn) ? L_FILE : 0) | (ops->is_directory(fn) ? L_DIRECTORY : 0));
+	    (ops->is_file(fn) ? L_FILE : 0) |
+	    (ops->is_directory(fn) ? L_DIRECTORY : 0));
 	
 	(void) ops->node_put(fn);
Index: uspace/lib/fs/libfs.h
===================================================================
--- uspace/lib/fs/libfs.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/fs/libfs.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -56,12 +56,4 @@
 
 typedef struct {
-	bool mp_active;
-	async_sess_t *sess;
-	fs_handle_t fs_handle;
-	service_id_t service_id;
-} mp_data_t;
-
-typedef struct {
-	mp_data_t mp_data;  /**< Mount point info. */
 	void *data;         /**< Data of the file system implementation. */
 } fs_node_t;
Index: uspace/lib/gui/window.c
===================================================================
--- uspace/lib/gui/window.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/gui/window.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -37,4 +37,5 @@
 #include <errno.h>
 #include <stdio.h>
+#include <stdlib.h>
 
 #include <as.h>
Index: uspace/lib/pcut/src/os/generic.c
===================================================================
--- uspace/lib/pcut/src/os/generic.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/pcut/src/os/generic.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -137,5 +137,5 @@
 	fread(extra_output_buffer, 1, OUTPUT_BUFFER_SIZE, tempfile);
 	fclose(tempfile);
-	remove(tempfile_name);
+	unlink(tempfile_name);
 
 	pcut_report_test_done_unparsed(test, rc, extra_output_buffer, OUTPUT_BUFFER_SIZE);
Index: uspace/lib/pcut/src/os/helenos.c
===================================================================
--- uspace/lib/pcut/src/os/helenos.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/pcut/src/os/helenos.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -41,6 +41,6 @@
 #include <stdio.h>
 #include <task.h>
-#include <fcntl.h>
 #include <fibril_synch.h>
+#include <vfs/vfs.h>
 #include "../internal.h"
 
@@ -161,5 +161,5 @@
 	char tempfile_name[PCUT_TEMP_FILENAME_BUFFER_SIZE];
 	snprintf(tempfile_name, PCUT_TEMP_FILENAME_BUFFER_SIZE - 1, "pcut_%lld.tmp", (unsigned long long) task_get_id());
-	int tempfile = open(tempfile_name, O_CREAT | O_RDWR);
+	int tempfile = vfs_lookup_open(tempfile_name, WALK_REGULAR | WALK_MAY_CREATE, MODE_READ | MODE_WRITE);
 	if (tempfile < 0) {
 		pcut_report_test_done(test, TEST_OUTCOME_ERROR, "Failed to create temporary file.", NULL, NULL);
@@ -169,11 +169,4 @@
 	char test_number_argument[MAX_TEST_NUMBER_WIDTH];
 	snprintf(test_number_argument, MAX_TEST_NUMBER_WIDTH, "-t%d", test->id);
-
-	int *files[4];
-	int fd_stdin = fileno(stdin);
-	files[0] = &fd_stdin;
-	files[1] = &tempfile;
-	files[2] = &tempfile;
-	files[3] = NULL;
 
 	const char *const arguments[3] = {
@@ -186,5 +179,6 @@
 
 	task_wait_t test_task_wait;
-	int rc = task_spawnvf(&test_task_id, &test_task_wait, self_path, arguments, files);
+	int rc = task_spawnvf(&test_task_id, &test_task_wait, self_path, arguments,
+	    fileno(stdin), tempfile, tempfile);
 	if (rc != EOK) {
 		status = TEST_OUTCOME_ERROR;
@@ -220,9 +214,10 @@
 	fibril_mutex_unlock(&forced_termination_mutex);
 
-	read(tempfile, extra_output_buffer, OUTPUT_BUFFER_SIZE);
+	aoff64_t pos = 0;
+	vfs_read(tempfile, &pos, extra_output_buffer, OUTPUT_BUFFER_SIZE);
 
 leave_close_tempfile:
-	close(tempfile);
-	unlink(tempfile_name);
+	vfs_put(tempfile);
+	vfs_unlink_path(tempfile_name);
 
 	pcut_report_test_done_unparsed(test, status, extra_output_buffer, OUTPUT_BUFFER_SIZE);
Index: uspace/lib/posix/include/posix/fcntl.h
===================================================================
--- uspace/lib/posix/include/posix/fcntl.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/posix/include/posix/fcntl.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -41,6 +41,20 @@
 
 #include "sys/types.h"
-#include "libc/fcntl.h"
 #include "errno.h"
+
+#undef O_CREAT
+#undef O_EXCL
+#undef O_TRUNC
+#undef O_APPEND
+#undef O_RDONLY
+#undef O_RDWR
+#undef O_WRONLY
+#define O_CREAT   1
+#define O_EXCL    2
+#define O_TRUNC   4
+#define O_APPEND  8
+#define O_RDONLY  16
+#define O_RDWR    32
+#define O_WRONLY  64
 
 /* Mask for file access modes. */
Index: uspace/lib/posix/include/posix/sys/stat.h
===================================================================
--- uspace/lib/posix/include/posix/sys/stat.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/posix/include/posix/sys/stat.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -115,5 +115,5 @@
 	__POSIX_DEF__(dev_t)     st_dev;     /* ID of device containing file */
 	__POSIX_DEF__(ino_t)     st_ino;     /* inode number */
-	mode_t          st_mode;    /* protection */
+	__POSIX_DEF__(mode_t)    st_mode;    /* protection */
 	__POSIX_DEF__(nlink_t)   st_nlink;   /* number of hard links */
 	__POSIX_DEF__(uid_t)     st_uid;     /* user ID of owner */
@@ -131,7 +131,7 @@
 extern int __POSIX_DEF__(lstat)(const char *restrict path, struct __POSIX_DEF__(stat) *restrict st);
 extern int __POSIX_DEF__(stat)(const char *restrict path, struct __POSIX_DEF__(stat) *restrict st);
-extern int __POSIX_DEF__(chmod)(const char *path, mode_t mode);
-extern mode_t __POSIX_DEF__(umask)(mode_t mask);
-extern int mkdir(const char *, mode_t);
+extern int __POSIX_DEF__(chmod)(const char *path, __POSIX_DEF__(mode_t) mode);
+extern __POSIX_DEF__(mode_t) __POSIX_DEF__(umask)(__POSIX_DEF__(mode_t) mask);
+extern int __POSIX_DEF__(mkdir)(const char *path, __POSIX_DEF__(mode_t) mode);
 
 
Index: uspace/lib/posix/include/posix/sys/types.h
===================================================================
--- uspace/lib/posix/include/posix/sys/types.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/posix/include/posix/sys/types.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -53,4 +53,5 @@
 typedef int64_t __POSIX_DEF__(pid_t);
 typedef sysarg_t __POSIX_DEF__(dev_t);
+typedef unsigned int __POSIX_DEF__(mode_t);
 
 /* PThread Types */
Index: uspace/lib/posix/source/fcntl.c
===================================================================
--- uspace/lib/posix/source/fcntl.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/posix/source/fcntl.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -100,19 +100,64 @@
  *
  * @param pathname Path to the file.
- * @param flags Access mode flags.
+ * @param posix_flags Access mode flags.
  */
-int posix_open(const char *pathname, int flags, ...)
+int posix_open(const char *pathname, int posix_flags, ...)
 {
-	mode_t mode = 0;
-	if ((flags & O_CREAT) > 0) {
+	int rc;
+	posix_mode_t posix_mode = 0;
+	if (posix_flags & O_CREAT) {
 		va_list args;
-		va_start(args, flags);
-		mode = va_arg(args, mode_t);
+		va_start(args, posix_flags);
+		posix_mode = va_arg(args, posix_mode_t);
 		va_end(args);
+		(void) posix_mode;
 	}
 
-	return negerrno(open, pathname, flags, mode);
+	if (((posix_flags & (O_RDONLY | O_WRONLY | O_RDWR)) == 0) ||
+	    ((posix_flags & (O_RDONLY | O_WRONLY)) == (O_RDONLY | O_WRONLY)) ||
+	    ((posix_flags & (O_RDONLY | O_RDWR)) == (O_RDONLY | O_RDWR)) ||
+	    ((posix_flags & (O_WRONLY | O_RDWR)) == (O_WRONLY | O_RDWR))) {
+		errno = EINVAL;
+		return -1;
+	}
+
+	int flags = WALK_REGULAR;
+	if (posix_flags & O_CREAT) {
+		if (posix_flags & O_EXCL)
+			flags |= WALK_MUST_CREATE;
+		else
+			flags |= WALK_MAY_CREATE;
+	}
+
+	int mode =
+	    ((posix_flags & O_RDWR) ? MODE_READ | MODE_WRITE : 0) |
+	    ((posix_flags & O_RDONLY) ? MODE_READ : 0) |
+	    ((posix_flags & O_WRONLY) ? MODE_WRITE : 0) |
+	    ((posix_flags & O_APPEND) ? MODE_APPEND : 0);
+
+	int file = rcerrno(vfs_lookup, pathname, flags);
+	if (file < 0)
+		return -1;
+
+	rc = rcerrno(vfs_open, file, mode);
+	if (rc != EOK) {
+		vfs_put(file);
+		return -1;
+	}
+
+	if (posix_flags & O_TRUNC) {
+		if (posix_flags & (O_RDWR | O_WRONLY)) {
+			rc = rcerrno(vfs_resize, file, 0);
+			if (rc != EOK) {
+				vfs_put(file);
+				return -1;
+			}
+		}
+	}
+
+	return file;
 }
 
 /** @}
  */
+
Index: uspace/lib/posix/source/internal/common.h
===================================================================
--- uspace/lib/posix/source/internal/common.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/posix/source/internal/common.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -38,4 +38,6 @@
 #include <stdio.h>
 #include <stdlib.h>
+#include <sys/types.h>
+#include <vfs/vfs.h>
 
 #define not_implemented() do { \
@@ -57,4 +59,14 @@
 })
 
+/* Convert error code to positive errno and -1 return value */
+#define rcerrno(func, ...) ({ \
+	int rc = func(__VA_ARGS__); \
+	if (rc < 0) \
+		errno = -rc; \
+	rc; \
+})
+
+extern aoff64_t posix_pos[MAX_OPEN_FILES];
+
 #endif /* LIBPOSIX_COMMON_H_ */
 
